diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/js/imgareaselect/jquery.imgareaselect.dev.js ./wordpress-3.4/wp-includes/js/imgareaselect/jquery.imgareaselect.dev.js
*** ./wordpress-3.3.2/wp-includes/js/imgareaselect/jquery.imgareaselect.dev.js	2011-05-15 13:03:51.000000000 -0500
--- ./wordpress-3.4/wp-includes/js/imgareaselect/jquery.imgareaselect.dev.js	2012-04-25 16:49:57.000000000 -0500
***************
*** 603,614 ****
          if (o = options.borderColor2)
              $($border[1]).css({ borderStyle: 'dashed', borderColor: o });
  
          $box.append($area.add($border).add($areaOpera).add($handles));
  
          if ($.browser.msie) {
!             if (o = $outer.css('filter').match(/opacity=([0-9]+)/))
                  $outer.css('opacity', o[1]/100);
!             if (o = $border.css('filter').match(/opacity=([0-9]+)/))
                  $border.css('opacity', o[1]/100);
          }
  
--- 961,973 ----
          if (o = options.borderColor2)
              $($border[1]).css({ borderStyle: 'dashed', borderColor: o });
  
+         /* Append all the selection area elements to the container box */
          $box.append($area.add($border).add($areaOpera).add($handles));
  
          if ($.browser.msie) {
!             if (o = $outer.css('filter').match(/opacity=(\d+)/))
                  $outer.css('opacity', o[1]/100);
!             if (o = $border.css('filter').match(/opacity=(\d+)/))
                  $border.css('opacity', o[1]/100);
          }
  
***************
*** 620,635 ****
--- 979,997 ----
              doUpdate();
          }
  
+         /* Calculate the aspect ratio factor */
          aspectRatio = (d = (options.aspectRatio || '').split(/:/))[0] / d[1];
  
          $img.add($outer).unbind('mousedown', imgMouseDown);
  
          if (options.disable || options.enable === false) {
+             /* Disable the plugin */
              $box.unbind('mousemove', areaMouseMove).unbind('mousedown', areaMouseDown);
              $(window).unbind('resize', windowResize);
          }
          else {
              if (options.enable || options.disable === false) {
+                 /* Enable the plugin */
                  if (options.resizable || options.movable)
                      $box.mousemove(areaMouseMove).mousedown(areaMouseDown);
  
***************
*** 643,711 ****
          options.enable = options.disable = undefined;
      }
  
      this.remove = function () {
          setOptions({ disable: true });
          $box.add($outer).remove();
      };
  
      this.getOptions = function () { return options; };
  
      this.setOptions = setOptions;
  
      this.getSelection = getSelection;
  
      this.setSelection = setSelection;
  
      this.update = doUpdate;
  
      $p = $img;
  
      while ($p.length) {
          zIndex = max(zIndex,
              !isNaN($p.css('z-index')) ? $p.css('z-index') : zIndex);
          if ($p.css('position') == 'fixed')
              position = 'fixed';
  
          $p = $p.parent(':not(body)');
      }
  
      zIndex = options.zIndex || zIndex;
  
      if ($.browser.msie)
          $img.attr('unselectable', 'on');
  
      $.imgAreaSelect.keyPress = $.browser.msie ||
          $.browser.safari ? 'keydown' : 'keypress';
  
      if ($.browser.opera)
          $areaOpera = div().css({ width: '100%', height: '100%',
              position: 'absolute', zIndex: zIndex + 2 || 2 });
  
      $box.add($outer).css({ visibility: 'hidden', position: position,
          overflow: 'hidden', zIndex: zIndex || '0' });
      $box.css({ zIndex: zIndex + 2 || 2 });
      $area.add($border).css({ position: 'absolute', fontSize: 0 });
  
      img.complete || img.readyState == 'complete' || !$img.is('img') ?
          imgLoad() : $img.one('load', imgLoad);
  
!     if ($.browser.msie && $.browser.version >= 9)
          img.src = img.src;
  };
  
  $.fn.imgAreaSelect = function (options) {
      options = options || {};
  
      this.each(function () {
          if ($(this).data('imgAreaSelect')) {
              if (options.remove) {
                  $(this).data('imgAreaSelect').remove();
                  $(this).removeData('imgAreaSelect');
              }
              else
                  $(this).data('imgAreaSelect').setOptions(options);
          }
          else if (!options.remove) {
              if (options.enable === undefined && options.disable === undefined)
                  options.enable = true;
  
--- 1005,1183 ----
          options.enable = options.disable = undefined;
      }
  
+     /**
+      * Remove plugin completely
+      */
      this.remove = function () {
+         /*
+          * Call setOptions with { disable: true } to unbind the event handlers
+          */
          setOptions({ disable: true });
          $box.add($outer).remove();
      };
  
+     /*
+      * Public API
+      */
+ 
+     /**
+      * Get current options
+      *
+      * @return An object containing the set of options currently in use
+      */
      this.getOptions = function () { return options; };
  
+     /**
+      * Set plugin options
+      *
+      * @param newOptions
+      *            The new options object
+      */
      this.setOptions = setOptions;
  
+     /**
+      * Get the current selection
+      *
+      * @param noScale
+      *            If set to <code>true</code>, scaling is not applied to the
+      *            returned selection
+      * @return Selection object
+      */
      this.getSelection = getSelection;
  
+     /**
+      * Set the current selection
+      *
+      * @param x1
+      *            X coordinate of the upper left corner of the selection area
+      * @param y1
+      *            Y coordinate of the upper left corner of the selection area
+      * @param x2
+      *            X coordinate of the lower right corner of the selection area
+      * @param y2
+      *            Y coordinate of the lower right corner of the selection area
+      * @param noScale
+      *            If set to <code>true</code>, scaling is not applied to the
+      *            new selection
+      */
      this.setSelection = setSelection;
  
+     /**
+      * Cancel selection
+      */
+     this.cancelSelection = cancelSelection;
+ 
+     /**
+      * Update plugin elements
+      *
+      * @param resetKeyPress
+      *            If set to <code>false</code>, this instance's keypress
+      *            event handler is not activated
+      */
      this.update = doUpdate;
  
+     /*
+      * Traverse the image's parent elements (up to <body>) and find the
+      * highest z-index
+      */
      $p = $img;
  
      while ($p.length) {
          zIndex = max(zIndex,
              !isNaN($p.css('z-index')) ? $p.css('z-index') : zIndex);
+         /* Also check if any of the ancestor elements has fixed position */
          if ($p.css('position') == 'fixed')
              position = 'fixed';
  
          $p = $p.parent(':not(body)');
      }
  
+     /*
+      * If z-index is given as an option, it overrides the one found by the
+      * above loop
+      */
      zIndex = options.zIndex || zIndex;
  
      if ($.browser.msie)
          $img.attr('unselectable', 'on');
  
+     /*
+      * In MSIE and WebKit, we need to use the keydown event instead of keypress
+      */
      $.imgAreaSelect.keyPress = $.browser.msie ||
          $.browser.safari ? 'keydown' : 'keypress';
  
+     /*
+      * There is a bug affecting the CSS cursor property in Opera (observed in
+      * versions up to 10.00) that prevents the cursor from being updated unless
+      * the mouse leaves and enters the element again. To trigger the mouseover
+      * event, we're adding an additional div to $box and we're going to toggle
+      * it when mouse moves inside the selection area.
+      */
      if ($.browser.opera)
          $areaOpera = div().css({ width: '100%', height: '100%',
              position: 'absolute', zIndex: zIndex + 2 || 2 });
  
+     /*
+      * We initially set visibility to "hidden" as a workaround for a weird
+      * behaviour observed in Google Chrome 1.0.154.53 (on Windows XP). Normally
+      * we would just set display to "none", but, for some reason, if we do so
+      * then Chrome refuses to later display the element with .show() or
+      * .fadeIn().
+      */
      $box.add($outer).css({ visibility: 'hidden', position: position,
          overflow: 'hidden', zIndex: zIndex || '0' });
      $box.css({ zIndex: zIndex + 2 || 2 });
      $area.add($border).css({ position: 'absolute', fontSize: 0 });
  
+     /*
+      * If the image has been fully loaded, or if it is not really an image (eg.
+      * a div), call imgLoad() immediately; otherwise, bind it to be called once
+      * on image load event.
+      */
      img.complete || img.readyState == 'complete' || !$img.is('img') ?
          imgLoad() : $img.one('load', imgLoad);
  
!     /*
!      * MSIE 9.0 doesn't always fire the image load event -- resetting the src
!      * attribute seems to trigger it. The check is for version 7 and above to
!      * accommodate for MSIE 9 running in compatibility mode.
!      */
!    if ($.browser.msie && $.browser.version >= 7)
          img.src = img.src;
  };
  
+ /**
+  * Invoke imgAreaSelect on a jQuery object containing the image(s)
+  *
+  * @param options
+  *            Options object
+  * @return The jQuery object or a reference to imgAreaSelect instance (if the
+  *         <code>instance</code> option was specified)
+  */
  $.fn.imgAreaSelect = function (options) {
      options = options || {};
  
      this.each(function () {
+         /* Is there already an imgAreaSelect instance bound to this element? */
          if ($(this).data('imgAreaSelect')) {
+             /* Yes there is -- is it supposed to be removed? */
              if (options.remove) {
+                 /* Remove the plugin */
                  $(this).data('imgAreaSelect').remove();
                  $(this).removeData('imgAreaSelect');
              }
              else
+                 /* Reset options */
                  $(this).data('imgAreaSelect').setOptions(options);
          }
          else if (!options.remove) {
+             /* No exising instance -- create a new one */
+ 
+             /*
+              * If neither the "enable" nor the "disable" option is present, add
+              * "enable" as the default
+              */
              if (options.enable === undefined && options.disable === undefined)
                  options.enable = true;
  
***************
*** 714,719 ****
--- 1186,1195 ----
      });
  
      if (options.instance)
+         /*
+          * Return the imgAreaSelect instance bound to the first element in the
+          * set
+          */
          return $(this).data('imgAreaSelect');
  
      return this;
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/js/jquery/jquery.form.js ./wordpress-3.4/wp-includes/js/jquery/jquery.form.js
*** ./wordpress-3.3.2/wp-includes/js/jquery/jquery.form.js	2011-05-17 09:22:50.000000000 -0500
--- ./wordpress-3.4/wp-includes/js/jquery/jquery.form.js	2012-02-01 08:37:52.000000000 -0600
***************
*** 1,4 ****
! /*
   * jQuery Form Plugin
   * version: 2.73 (03-MAY-2011)
   * @requires jQuery v1.3.2 or later
--- 1,4 ----
! /*!
   * jQuery Form Plugin
   * version: 2.73 (03-MAY-2011)
   * @requires jQuery v1.3.2 or later
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/js/jquery/jquery.hotkeys.dev.js ./wordpress-3.4/wp-includes/js/jquery/jquery.hotkeys.dev.js
*** ./wordpress-3.3.2/wp-includes/js/jquery/jquery.hotkeys.dev.js	2009-01-02 09:08:58.000000000 -0600
--- ./wordpress-3.4/wp-includes/js/jquery/jquery.hotkeys.dev.js	2012-06-09 10:57:11.000000000 -0500
***************
*** 51,60 ****
          
          // inspect if keystroke matches
          var inspector = function(event) {
!             event = jQuery.event.fix(event); // jQuery event normalization.
              var element = event.target;
              // @ TextNode -> nodeType == 3
!             element = (element.nodeType==3) ? element.parentNode : element;
              
              if(opt['disableInInput']) { // Disable shortcut keys in Input, Textarea fields
                  var target = jQuery(element);
--- 51,62 ----
          
          // inspect if keystroke matches
          var inspector = function(event) {
!             // WP: not needed with newer jQuery
!             // event = jQuery.event.fix(event); // jQuery event normalization.
              var element = event.target;
              // @ TextNode -> nodeType == 3
!             // WP: not needed with newer jQuery
!             // element = (element.nodeType==3) ? element.parentNode : element;
              
              if(opt['disableInInput']) { // Disable shortcut keys in Input, Textarea fields
                  var target = jQuery(element);
***************
*** 76,86 ****
              // in opera + safari, the event.target is unpredictable.
              // for example: 'keydown' might be associated with HtmlBodyElement 
              // or the element where you last clicked with your mouse.
!             if (jQuery.browser.opera || jQuery.browser.safari){
                  while (!that.all[element] && element.parentNode){
                      element = element.parentNode;
                  }
!             }
              var cbMap = that.all[element].events[type].callbackMap;
              if(!shift && !ctrl && !alt && !meta) { // No Modifiers
                  mapPoint = cbMap[special] ||  cbMap[character]
--- 78,89 ----
              // in opera + safari, the event.target is unpredictable.
              // for example: 'keydown' might be associated with HtmlBodyElement 
              // or the element where you last clicked with your mouse.
!             // WP: needed for all browsers 
!             // if (jQuery.browser.opera || jQuery.browser.safari){
                  while (!that.all[element] && element.parentNode){
                      element = element.parentNode;
                  }
!             // }
              var cbMap = that.all[element].events[type].callbackMap;
              if(!shift && !ctrl && !alt && !meta) { // No Modifiers
                  mapPoint = cbMap[special] ||  cbMap[character]
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/js/jquery/jquery.ui.touch-punch.js ./wordpress-3.4/wp-includes/js/jquery/jquery.ui.touch-punch.js
*** ./wordpress-3.3.2/wp-includes/js/jquery/jquery.ui.touch-punch.js	1969-12-31 18:00:00.000000000 -0600
--- ./wordpress-3.4/wp-includes/js/jquery/jquery.ui.touch-punch.js	2012-04-10 21:58:23.000000000 -0500
***************
*** 0 ****
--- 1,11 ----
+ /*!
+  * jQuery UI Touch Punch 0.2.2
+  *
+  * Copyright 2011, Dave Furfero
+  * Dual licensed under the MIT or GPL Version 2 licenses.
+  *
+  * Depends:
+  *  jquery.ui.widget.js
+  *  jquery.ui.mouse.js
+  */
+ (function(b){b.support.touch="ontouchend" in document;if(!b.support.touch){return}var c=b.ui.mouse.prototype,e=c._mouseInit,a;function d(g,h){if(g.originalEvent.touches.length>1){return}g.preventDefault();var i=g.originalEvent.changedTouches[0],f=document.createEvent("MouseEvents");f.initMouseEvent(h,true,true,window,1,i.screenX,i.screenY,i.clientX,i.clientY,false,false,false,false,0,null);g.target.dispatchEvent(f)}c._touchStart=function(g){var f=this;if(a||!f._mouseCapture(g.originalEvent.changedTouches[0])){return}a=true;f._touchMoved=false;d(g,"mouseover");d(g,"mousemove");d(g,"mousedown")};c._touchMove=function(f){if(!a){return}this._touchMoved=true;d(f,"mousemove")};c._touchEnd=function(f){if(!a){return}d(f,"mouseup");d(f,"mouseout");if(!this._touchMoved){d(f,"click")}a=false};c._mouseInit=function(){var f=this;f.element.bind("touchstart",b.proxy(f,"_touchStart")).bind("touchmove",b.proxy(f,"_touchMove")).bind("touchend",b.proxy(f,"_touchEnd"));e.call(f)}})(jQuery);
\ No newline at end of file
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/js/plupload/handlers.dev.js ./wordpress-3.4/wp-includes/js/plupload/handlers.dev.js
*** ./wordpress-3.3.2/wp-includes/js/plupload/handlers.dev.js	2012-04-16 17:46:36.000000000 -0500
--- ./wordpress-3.4/wp-includes/js/plupload/handlers.dev.js	2012-06-01 20:39:00.000000000 -0500
***************
*** 83,89 ****
  	serverData = serverData.replace(/^<pre>(\d+)<\/pre>$/, '$1');
  
  	// if async-upload returned an error message, place it in the media item div and return
! 	if ( serverData.match('media-upload-error') ) {
  		item.html(serverData);
  		return;
  	} else {
--- 83,89 ----
  	serverData = serverData.replace(/^<pre>(\d+)<\/pre>$/, '$1');
  
  	// if async-upload returned an error message, place it in the media item div and return
! 	if ( serverData.match(/media-upload-error|error-div/) ) {
  		item.html(serverData);
  		return;
  	} else {
***************
*** 138,144 ****
  	jQuery('a.delete', item).click(function(){
  		// Tell the server to delete it. TODO: handle exceptions
  		jQuery.ajax({
! 			url: 'admin-ajax.php',
  			type: 'post',
  			success: deleteSuccess,
  			error: deleteError,
--- 138,144 ----
  	jQuery('a.delete', item).click(function(){
  		// Tell the server to delete it. TODO: handle exceptions
  		jQuery.ajax({
! 			url: ajaxurl,
  			type: 'post',
  			success: deleteSuccess,
  			error: deleteError,
***************
*** 156,162 ****
  	jQuery('a.undo', item).click(function(){
  		// Tell the server to untrash it. TODO: handle exceptions
  		jQuery.ajax({
! 			url: 'admin-ajax.php',
  			type: 'post',
  			id: fileObj.id,
  			data: {
--- 156,162 ----
  	jQuery('a.undo', item).click(function(){
  		// Tell the server to untrash it. TODO: handle exceptions
  		jQuery.ajax({
! 			url: ajaxurl,
  			type: 'post',
  			id: fileObj.id,
  			data: {
***************
*** 346,354 ****
  		if ( target.is('input[type="radio"]') ) { // remember the last used image size and alignment
  			tr = target.closest('tr');
  
! 			if ( $(tr).hasClass('align') )
  				setUserSetting('align', target.val());
! 			else if ( $(tr).hasClass('image-size') )
  				setUserSetting('imgsize', target.val());
  
  		} else if ( target.is('button.button') ) { // remember the last used image link url
--- 346,354 ----
  		if ( target.is('input[type="radio"]') ) { // remember the last used image size and alignment
  			tr = target.closest('tr');
  
! 			if ( tr.hasClass('align') )
  				setUserSetting('align', target.val());
! 			else if ( tr.hasClass('image-size') )
  				setUserSetting('imgsize', target.val());
  
  		} else if ( target.is('button.button') ) { // remember the last used image link url
***************
*** 357,363 ****
  
  			if ( c && c[1] ) {
  				setUserSetting('urlbutton', c[1]);
! 				target.siblings('.urlfield').val( target.attr('title') );
  			}
  		} else if ( target.is('a.dismiss') ) {
  			target.parents('.media-item').fadeOut(200, function(){
--- 357,363 ----
  
  			if ( c && c[1] ) {
  				setUserSetting('urlbutton', c[1]);
! 				target.siblings('.urlfield').val( target.data('link-url') );
  			}
  		} else if ( target.is('a.dismiss') ) {
  			target.parents('.media-item').fadeOut(200, function(){
***************
*** 366,376 ****
  		} else if ( target.is('.upload-flash-bypass a') || target.is('a.uploader-html') ) { // switch uploader to html4
  			$('#media-items, p.submit, span.big-file-warning').css('display', 'none');
  			switchUploader(0);
! 			return false;
  		} else if ( target.is('.upload-html-bypass a') ) { // switch uploader to multi-file
  			$('#media-items, p.submit, span.big-file-warning').css('display', '');
  			switchUploader(1);
! 			return false;
  		} else if ( target.is('a.describe-toggle-on') ) { // Show
  			target.parent().addClass('open');
  			target.siblings('.slidetoggle').fadeIn(250, function(){
--- 366,376 ----
  		} else if ( target.is('.upload-flash-bypass a') || target.is('a.uploader-html') ) { // switch uploader to html4
  			$('#media-items, p.submit, span.big-file-warning').css('display', 'none');
  			switchUploader(0);
! 			e.preventDefault();
  		} else if ( target.is('.upload-html-bypass a') ) { // switch uploader to multi-file
  			$('#media-items, p.submit, span.big-file-warning').css('display', '');
  			switchUploader(1);
! 			e.preventDefault();
  		} else if ( target.is('a.describe-toggle-on') ) { // Show
  			target.parent().addClass('open');
  			target.siblings('.slidetoggle').fadeIn(250, function(){
***************
*** 388,399 ****
  					}
  				}
  			});
! 			return false;
  		} else if ( target.is('a.describe-toggle-off') ) { // Hide
  			target.siblings('.slidetoggle').fadeOut(250, function(){
  				target.parent().removeClass('open');
  			});
! 			return false;
  		}
  	});
  
--- 388,399 ----
  					}
  				}
  			});
! 			e.preventDefault();
  		} else if ( target.is('a.describe-toggle-off') ) { // Hide
  			target.siblings('.slidetoggle').fadeOut(250, function(){
  				target.parent().removeClass('open');
  			});
! 			e.preventDefault();
  		}
  	});
  
***************
*** 417,423 ****
  
  			setResize( getUserSetting('upload_resize', false) );
  
! 			if ( up.features.dragdrop ) {
  				uploaddiv.addClass('drag-drop');
  				$('#drag-drop-area').bind('dragover.wp-uploader', function(){ // dragenter doesn't fire right :(
  					uploaddiv.addClass('drag-over');
--- 417,423 ----
  
  			setResize( getUserSetting('upload_resize', false) );
  
! 			if ( up.features.dragdrop && ! $(document.body).hasClass('mobile') ) {
  				uploaddiv.addClass('drag-drop');
  				$('#drag-drop-area').bind('dragover.wp-uploader', function(){ // dragenter doesn't fire right :(
  					uploaddiv.addClass('drag-over');
diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.4.pl ./wordpress-3.3.2/wp-includes/js/plupload/wp-plupload.dev.js ./wordpress-3.4/wp-includes/js/plupload/wp-plupload.dev.js
*** ./wordpress-3.3.2/wp-includes/js/plupload/wp-plupload.dev.js	1969-12-31 18:00:00.000000000 -0600
--- ./wordpress-3.4/wp-includes/js/plupload/wp-plupload.dev.js	2012-06-06 16:45:17.000000000 -0500
***************
*** 0 ****
--- 1,220 ----
+ if ( typeof wp === 'undefined' )
+ 	var wp = {};
+ 
+ (function( exports, $ ) {
+ 	var Uploader;
+ 
+ 	if ( typeof _wpPluploadSettings === 'undefined' )
+ 		return;
+ 
+ 	/*
+ 	 * An object that helps create a WordPress uploader using plupload.
+ 	 *
+ 	 * @param options - object - The options passed to the new plupload instance.
+ 	 *    Requires the following parameters:
+ 	 *    - container - The id of uploader container.
+ 	 *    - browser   - The id of button to trigger the file select.
+ 	 *    - dropzone  - The id of file drop target.
+ 	 *    - plupload  - An object of parameters to pass to the plupload instance.
+ 	 *    - params    - An object of parameters to pass to $_POST when uploading the file.
+ 	 *                  Extends this.plupload.multipart_params under the hood.
+ 	 *
+ 	 * @param attributes - object - Attributes and methods for this specific instance.
+ 	 */
+ 	Uploader = function( options ) {
+ 		var self = this,
+ 			elements = {
+ 				container: 'container',
+ 				browser:   'browse_button',
+ 				dropzone:  'drop_element'
+ 			},
+ 			key;
+ 
+ 		this.supports = {
+ 			upload: Uploader.browser.supported
+ 		};
+ 
+ 		this.supported = this.supports.upload;
+ 
+ 		if ( ! this.supported )
+ 			return;
+ 
+ 		// Use deep extend to ensure that multipart_params and other objects are cloned.
+ 		this.plupload = $.extend( true, { multipart_params: {} }, Uploader.defaults );
+ 		this.container = document.body; // Set default container.
+ 
+ 		// Extend the instance with options
+ 		//
+ 		// Use deep extend to allow options.plupload to override individual
+ 		// default plupload keys.
+ 		$.extend( true, this, options );
+ 
+ 		// Proxy all methods so this always refers to the current instance.
+ 		for ( key in this ) {
+ 			if ( $.isFunction( this[ key ] ) )
+ 				this[ key ] = $.proxy( this[ key ], this );
+ 		}
+ 
+ 		// Ensure all elements are jQuery elements and have id attributes
+ 		// Then set the proper plupload arguments to the ids.
+ 		for ( key in elements ) {
+ 			if ( ! this[ key ] )
+ 				continue;
+ 
+ 			this[ key ] = $( this[ key ] ).first();
+ 
+ 			if ( ! this[ key ].length ) {
+ 				delete this[ key ];
+ 				continue;
+ 			}
+ 
+ 			if ( ! this[ key ].prop('id') )
+ 				this[ key ].prop( 'id', '__wp-uploader-id-' + Uploader.uuid++ );
+ 			this.plupload[ elements[ key ] ] = this[ key ].prop('id');
+ 		}
+ 
+ 		this.uploader = new plupload.Uploader( this.plupload );
+ 		delete this.plupload;
+ 
+ 		// Set default params and remove this.params alias.
+ 		this.param( this.params || {} );
+ 		delete this.params;
+ 
+ 		this.uploader.init();
+ 
+ 		this.supports.dragdrop = this.uploader.features.dragdrop && ! Uploader.browser.mobile;
+ 
+ 		// Generate drag/drop helper classes.
+ 		(function( dropzone, supported ) {
+ 			var sensitivity = 50,
+ 				active;
+ 
+ 			if ( ! dropzone )
+ 				return;
+ 
+ 			dropzone.toggleClass( 'supports-drag-drop', !! supported );
+ 
+ 			if ( ! supported )
+ 				return dropzone.unbind('.wp-uploader');
+ 
+ 			// 'dragenter' doesn't fire correctly,
+ 			// simulate it with a limited 'dragover'
+ 			dropzone.bind( 'dragover.wp-uploader', function(){
+ 				if ( active )
+ 					return;
+ 
+ 				dropzone.addClass('drag-over');
+ 				active = true;
+ 			});
+ 
+ 			dropzone.bind('dragleave.wp-uploader, drop.wp-uploader', function(){
+ 				active = false;
+ 				dropzone.removeClass('drag-over');
+ 			});
+ 		}( this.dropzone, this.supports.dragdrop ));
+ 
+ 		this.browser.on( 'mouseenter', this.refresh );
+ 
+ 		this.uploader.bind( 'UploadProgress', this.progress );
+ 
+ 		this.uploader.bind( 'FileUploaded', function( up, file, response ) {
+ 			try {
+ 				response = JSON.parse( response.response );
+ 			} catch ( e ) {
+ 				return self.error( pluploadL10n.default_error, e );
+ 			}
+ 
+ 			if ( ! response || ! response.type || ! response.data )
+ 				return self.error( pluploadL10n.default_error );
+ 
+ 			if ( 'error' === response.type )
+ 				return self.error( response.data.message, response.data );
+ 
+ 			if ( 'success' === response.type )
+ 				return self.success( response.data );
+ 
+ 		});
+ 
+ 		this.uploader.bind( 'Error', function( up, error ) {
+ 			var message = pluploadL10n.default_error,
+ 				key;
+ 
+ 			// Check for plupload errors.
+ 			for ( key in Uploader.errorMap ) {
+ 				if ( error.code === plupload[ key ] ) {
+ 					message = Uploader.errorMap[ key ];
+ 					break;
+ 				}
+ 			}
+ 
+ 			self.error( message, error );
+ 			up.refresh();
+ 		});
+ 
+ 		this.uploader.bind( 'FilesAdded', function( up, files ) {
+ 			$.each( files, function() {
+ 				self.added( this );
+ 			});
+ 
+ 			up.refresh();
+ 			up.start();
+ 		});
+ 
+ 		this.init();
+ 	};
+ 
+ 	// Adds the 'defaults' and 'browser' properties.
+ 	$.extend( Uploader, _wpPluploadSettings );
+ 
+ 	Uploader.uuid = 0;
+ 
+ 	Uploader.errorMap = {
+ 		'FAILED':                 pluploadL10n.upload_failed,
+ 		'FILE_EXTENSION_ERROR':   pluploadL10n.invalid_filetype,
+ 		// 'FILE_SIZE_ERROR': '',
+ 		'IMAGE_FORMAT_ERROR':     pluploadL10n.not_an_image,
+ 		'IMAGE_MEMORY_ERROR':     pluploadL10n.image_memory_exceeded,
+ 		'IMAGE_DIMENSIONS_ERROR': pluploadL10n.image_dimensions_exceeded,
+ 		'GENERIC_ERROR':          pluploadL10n.upload_failed,
+ 		'IO_ERROR':               pluploadL10n.io_error,
+ 		'HTTP_ERROR':             pluploadL10n.http_error,
+ 		'SECURITY_ERROR':         pluploadL10n.security_error
+ 	};
+ 
+ 	$.extend( Uploader.prototype, {
+ 		/**
+ 		 * Acts as a shortcut to extending the uploader's multipart_params object.
+ 		 *
+ 		 * param( key )
+ 		 *    Returns the value of the key.
+ 		 *
+ 		 * param( key, value )
+ 		 *    Sets the value of a key.
+ 		 *
+ 		 * param( map )
+ 		 *    Sets values for a map of data.
+ 		 */
+ 		param: function( key, value ) {
+ 			if ( arguments.length === 1 && typeof key === 'string' )
+ 				return this.uploader.settings.multipart_params[ key ];
+ 
+ 			if ( arguments.length > 1 ) {
+ 				this.uploader.settings.multipart_params[ key ] = value;
+ 			} else {
+ 				$.extend( this.uploader.settings.multipart_params, key );
+ 			}
+ 		},
+ 
+ 		init:     function() {},
+ 		error:    function() {},
+ 		success:  function() {},
+ 		added:    function() {},
+ 		progress: function() {},
+ 		complete: function() {},
+ 		refresh:  function() {
+ 			this.uploader.refresh();
+ 		}
+ 	});
+ 
+ 	exports.Uploader = Uploader;
+ })( wp, jQuery );
